<?xml version="1.0" encoding="UTF-8"?>

<cfsSimulation xmlns="http://www.cfs++.org/simulation">
  <documentation>
    <title>min compliance pfem test</title>
    <authors>
      <author>Bich Ngoc Vu</author>
    </authors>
    <date>2019-07-22</date>
    <keywords>
      <keyword>SIMP</keyword>
    </keywords>
    <references>Fabian Wein, thesis - book Kaltenbacher for pfem</references>
    <isVerified>yes</isVerified>
    <description>Standard compliance minimization with OCM and density filter and pfem (order 2). Otherwise like the 99 lines code</description>
  </documentation>

  <fileFormats>
    <output>
      <hdf5 />
      <info />
    </output>
    <materialData file="mat.xml" format="xml" />
  </fileFormats>

  <domain geometryType="plane">
    <regionList>
      <region material="99lines" name="mech" />
    </regionList>
    <!-- <nodeList> -->
    <!-- <nodes name="force"> -->
    <!-- <coord x="3" y="1"/> -->
    <!-- </nodes> -->
    <!-- </nodeList> -->
  </domain>


  <fePolynomialList>
    <Lagrange>
      <isoOrder serendipity="false">2</isoOrder>
    </Lagrange>
  </fePolynomialList>

  <sequenceStep index="1">
    <analysis>
      <static />
    </analysis>

    <pdeList>
      <mechanic subType="planeStrain">
        <regionList>
          <region name="mech" />
        </regionList>

        <bcsAndLoads>
          <fix name="west_surf">
            <comp dof="x" />
            <comp dof="y" />
          </fix>
          <pressure name="load_surf" value="-1"/>
          <!-- <force name="force"> -->
          <!-- <comp dof="y" value="-1"/> -->
          <!-- </force> -->
        </bcsAndLoads>
        <storeResults>
          <nodeResult type="mechDisplacement">
            <allRegions />
          </nodeResult>
          <elemResult type="physicalPseudoDensity">
            <allRegions />
          </elemResult>
        </storeResults>
      </mechanic>
    </pdeList>
    <linearSystems>
      <system>
        <solverList>
          <cholmod />
        </solverList>
      </system>
    </linearSystems>
  </sequenceStep>

  <optimization>
    <costFunction type="compliance" task="minimize">
      <stopping queue="999" value="0.002" type="designChange" />
    </costFunction>

    <constraint type="volume" bound="upperBound" value="0.3" />

    <optimizer type="optimalityCondition" maxIterations="10" />

    <ersatzMaterial region="mech" material="mechanic" method="simp">
      <filters>
        <filter neighborhood="maxEdge" value="1.1" type="density" />
      </filters>

      <design name="density" initial="0.3" physical_lower="1e-9" upper="1.0" />

      <transferFunction type="simp" application="mech" param="2" />
      <export write="iteration" save="all" />

    </ersatzMaterial>
    <commit mode="forward" stride="1" />
  </optimization>

</cfsSimulation>


